﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.Primitives;
using Telerik.WinControls.UI.Docking;
using Telerik.WinControls.Layouts;
using Telerik.WinControls.UI;

namespace ToolWindowCaptionImage
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            foreach (DockWindow window in this.radDock1.DockWindows)
            {
                if (window.DockState != DockState.Hidden && window.DockState != DockState.TabbedDocument)
                {
                    this.AddPrintButton(window);
                }
            }
            this.radDock1.TransactionCommitted += new RadDockTransactionEventHandler(radDock1_TransactionCommitted);
            
            this.toolWindow3.DockState = DockState.Floating;
        }

        private void radDock1_TransactionCommitted(object sender, RadDockTransactionEventArgs e)
        {
            foreach (DockWindow window in e.Transaction.AssociatedWindows)
            {
                this.AddPrintButton(window);
            }
        }

        private void AddPrintButton(DockWindow window)
        {
            if (window.DockState == DockState.Hidden || window.DockState == DockState.TabbedDocument)
            {
                return;
            }
            if (window.DockState == DockState.Floating)
            {
                window.FloatingParent.Shown += new EventHandler(FloatingParent_Shown);
                return;
            }

            DockLayoutPanel panel = ((ToolTabStrip)window.TabStrip).CaptionElement.Children[2] as DockLayoutPanel;
            if (panel.Children.Count < 5)
            {
                RadButtonElement radButtonElement = new RadButtonElement();
                radButtonElement.Text = "Print";
                panel.Children.Insert(3, radButtonElement);
            }
        }

        private void FloatingParent_Shown(object sender, EventArgs e)
        {
            FloatingWindow window = (FloatingWindow)sender;
            window.Shown -= new EventHandler(FloatingParent_Shown);

            if (window.FormElement.TitleBar.Children[2].Children[0] is RadButtonElement)
            {
                return;
            }

            RadButtonElement radButtonElement = new RadButtonElement();
            radButtonElement.Text = "Print";
            window.FormElement.TitleBar.Children[2].Children.Insert(0, radButtonElement);
        }
    }
}